Index: trunk/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 888)
+++ trunk/NEMO/OPA_SRC/SBC/sbcice_lim_2.F90	(revision 888)
@@ -0,0 +1,205 @@
+MODULE sbcice_lim_2
+   !!======================================================================
+   !!                       ***  MODULE  sbcice_lim_2  ***
+   !! Surface module :  update surface ocean boundary condition over ice
+   !!                   covered area using LIM sea-ice model
+   !! Sea-Ice model  :  LIM 2.0 Sea ice model time-stepping
+   !!======================================================================
+   !! History :  9.0   !  06-06  (G. Madec)  from icestp_2.F90
+   !!----------------------------------------------------------------------
+#if defined key_lim2
+   !!----------------------------------------------------------------------
+   !!   'key_lim2' :                                  LIM 2.0 sea-ice model
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   sbc_ice_lim_2  : sea-ice model time-stepping and
+   !!                    update ocean sbc over ice-covered area
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE ice_2
+   USE iceini_2
+   USE ice_oce         ! ice variables
+   USE dom_ice_2
+   USE cpl_oce
+
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+   USE sbc_ice         ! Surface boundary condition: ice   fields
+   USE sbcblk_core     ! Surface boundary condition: CORE bulk
+   USE sbcblk_clio     ! Surface boundary condition: CLIO bulk
+   USE albedo
+
+   USE daymod          ! day calendar
+   USE phycst          ! Define parameters for the routines
+   USE eosbn2          ! equation of state
+   USE limdyn_2
+   USE limtrp_2
+   USE limdmp_2
+   USE limthd_2
+   USE limsbc_2        ! sea surface boundary condition
+   USE limdia_2
+   USE limwri_2
+   USE limrst_2
+
+   USE lbclnk
+   USE iom             ! I/O manager library
+   USE in_out_manager  ! I/O manager
+   USE prtctl          ! Print control
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC sbc_ice_lim_2 ! routine called by sbcmod.F90
+   
+   CHARACTER(len=1) ::   cl_grid = 'B'     ! type of grid used in ice dynamics
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $ Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE sbc_ice_lim_2( kt, kblk )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE sbc_ice_lim_2  ***
+      !!                   
+      !! ** Purpose :   update the ocean surface boundary condition via the 
+      !!                Louvain la Neuve Sea Ice Model time stepping 
+      !!
+      !! ** Method  :   ice model time stepping
+      !!              - call the ice dynamics routine 
+      !!              - call the ice advection/diffusion routine 
+      !!              - call the ice thermodynamics routine 
+      !!              - call the routine that computes mass and 
+      !!                heat fluxes at the ice/ocean interface
+      !!              - save the outputs 
+      !!              - save the outputs for restart when necessary
+      !!
+      !! ** Action  : - time evolution of the LIM sea-ice model
+      !!              - update all sbc variables below sea-ice:
+      !!                utau, vtau, qns , qsr, emp , emps
+      !!---------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt      ! ocean time step
+      INTEGER, INTENT(in) ::   kblk    ! type of bulk (=3 CLIO, =4 CORE)
+      !!
+      INTEGER  ::   ji, jj   ! dummy loop indices
+      REAL(wp), DIMENSION(jpi,jpj,1) ::   alb_ice_os   ! albedo of the ice under overcast sky
+      REAL(wp), DIMENSION(jpi,jpj,1) ::   alb_ice_cs   ! albedo of ice under clear sky
+      REAL(wp), DIMENSION(jpi,jpj,1) ::   zsist        ! surface ice temperature (K)
+      REAL(wp), DIMENSION(jpi,jpj,1) ::   zhicif       ! ice thickness
+      REAL(wp), DIMENSION(jpi,jpj,1) ::   zhsnif       ! snow thickness
+      REAL(wp), DIMENSION(jpi,jpj,1) ::   zqns_ice     ! non solar sea-ice heat flux
+      REAL(wp), DIMENSION(jpi,jpj,1) ::   zqsr_ice     !     solar sea-ice heat flux
+      REAL(wp), DIMENSION(jpi,jpj,1) ::   zqla_ice     ! ice latent heat flux
+      REAL(wp), DIMENSION(jpi,jpj,1) ::   zdqns_ice    ! sensitivity ice net heat flux
+      REAL(wp), DIMENSION(jpi,jpj,1) ::   zdqla_ice    ! sensitivity ice latent heat flux
+      !!----------------------------------------------------------------------
+
+      IF( kt == nit000 ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'sbc_ice_lim_2 : update ocean surface boudary condition' 
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~~~~   via Louvain la Neuve Ice Model (LIM) time stepping'
+
+         CALL ice_init_2
+
+      ENDIF
+
+      IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN
+         !
+         ! ... mean surface ocean current at ice dynamics point
+         !     B-grid dynamics :  I-point (F-point with sea-ice indexation)
+         DO jj = 2, jpj
+            DO ji = fs_2, jpi   ! vector opt.
+               ui_oce(ji,jj) = 0.5 * ( ssu_m(ji-1,jj  ) + ssu_m(ji-1,jj-1) ) * tmu(ji,jj)
+               vi_oce(ji,jj) = 0.5 * ( ssv_m(ji  ,jj-1) + ssv_m(ji-1,jj-1) ) * tmu(ji,jj)
+            END DO
+         END DO
+         CALL lbc_lnk( ui_oce, 'I', -1. )   ! I-point (i.e. F-point with ice indices)
+         CALL lbc_lnk( vi_oce, 'I', -1. )   ! I-point (i.e. F-point with ice indices)
+
+         ! ... masked sea surface freezing temperature [Kelvin] (set to rt0 over land)
+         tfu(:,:) = tfreez( sss_m ) +  rt0 
+
+         zsist (:,:,1) = sist (:,:)
+         zhicif(:,:,1) = hicif(:,:)   ;   zhsnif(:,:,1) = hsnif(:,:)
+
+         ! ... ice albedo
+         CALL albedo_ice( zsist, zhicif, zhsnif, alb_ice_cs, alb_ice_os )
+
+         ! ... Sea-ice surface boundary conditions output from bulk formulae :
+         !     - utaui_ice  ! surface ice stress i-component (I-point)   [N/m2]
+         !     - vtaui_ice  ! surface ice stress j-component (I-point)   [N/m2]
+         !     - qns_ice    ! non solar heat flux over ice   (T-point)   [W/m2]
+         !     - qsr_ice    !     solar heat flux over ice   (T-point)   [W/m2]
+         !     - qla_ice    ! latent    heat flux over ice   (T-point)   [W/m2]
+         !     - dqns_ice   ! non solar heat sensistivity    (T-point)   [W/m2]
+         !     - dqla_ice   ! latent    heat sensistivity    (T-point)   [W/m2]
+         !     - tprecip    ! total precipitation            (T-point)   [Kg/m2/s]
+         !     - sprecip    ! solid precipitation            (T-point)   [Kg/m2/s]
+         !     - fr1_i0     ! 1sr fraction of qsr penetration in ice     [%]
+         !     - fr2_i0     ! 2nd fraction of qsr penetration in ice     [%]
+         !
+         SELECT CASE( kblk )
+         CASE( 3 )           ! CLIO bulk formulation
+            CALL blk_ice_clio( zsist , ui_ice , vi_ice   , alb_ice_cs , alb_ice_os ,             &
+               &                               utaui_ice , vtaui_ice  , zqns_ice   , zqsr_ice,   &
+               &                               zqla_ice  , zdqns_ice  , zdqla_ice  ,             &
+               &                               tprecip   , sprecip    ,                          &
+               &                               fr1_i0    , fr2_i0     , cl_grid  )
+         CASE( 4 )           ! CORE bulk formulation
+            CALL blk_ice_core( zsist , ui_ice , vi_ice   , alb_ice_cs ,                         &
+               &                               utaui_ice , vtaui_ice  , zqns_ice  , zqsr_ice,   &
+               &                               zqla_ice  , zdqns_ice  , zdqla_ice ,             &
+               &                               tprecip   , sprecip    ,                         &
+               &                               fr1_i0    , fr2_i0     , cl_grid)
+         END SELECT
+
+         qsr_ice(:,:) = zqsr_ice(:,:,1)
+         qns_ice(:,:) = zqns_ice(:,:,1)   ;   dqns_ice(:,:) = zdqns_ice(:,:,1)
+         qla_ice(:,:) = zqla_ice(:,:,1)   ;   dqla_ice(:,:) = zdqla_ice(:,:,1)
+
+         IF(ln_ctl) THEN         ! print mean trends (used for debugging)
+            CALL prt_ctl_info( 'Ice Forcings ' )
+            CALL prt_ctl( tab2d_1=tprecip  ,clinfo1=' sbc_ice_lim: precip   : ', tab2d_2=sprecip  , clinfo2=' Snow     : ' )
+            CALL prt_ctl( tab2d_1=utaui_ice,clinfo1=' sbc_ice_lim: utaui_ice: ', tab2d_2=vtaui_ice, clinfo2=' vtaui_ice: ' )
+            CALL prt_ctl( tab2d_1=sst_m    ,clinfo1=' sbc_ice_lim: sst      : ', tab2d_2=sss_m    , clinfo2=' sss      : ' )
+            CALL prt_ctl( tab2d_1=ui_oce   ,clinfo1=' sbc_ice_lim: u_io     : ', tab2d_2=vi_oce   , clinfo2=' v_io     : ' )
+            CALL prt_ctl( tab2d_1=hsnif    ,clinfo1=' sbc_ice_lim: hsnif  1 : ', tab2d_2=hicif    , clinfo2=' hicif    : ' )
+            CALL prt_ctl( tab2d_1=frld     ,clinfo1=' sbc_ice_lim: frld   1 : ', tab2d_2=sist     , clinfo2=' sist     : ' )
+         ENDIF
+
+         ! ---------------- !
+         !  Ice model step  !
+         ! ---------------- !
+         ;                              CALL lim_rst_opn_2  ( kt )      ! Open Ice restart file
+         ;                              CALL lim_dyn_2      ( kt )      ! Ice dynamics    ( rheology/dynamics )
+         ;                              CALL lim_trp_2      ( kt )      ! Ice transport   ( Advection/diffusion )
+         IF( ln_limdmp )                CALL lim_dmp_2      ( kt )      ! Ice damping 
+         ;                              CALL lim_thd_2      ( kt )      ! Ice thermodynamics 
+         ;                              CALL lim_sbc_2      ( kt )      ! Ice/Ocean Mass & Heat fluxes 
+         IF( MOD( kt+nn_fsbc-1, ninfo ) == 0 .OR.   &
+            &  ntmoy == 1 )             CALL lim_dia_2      ( kt )      ! Ice Diagnostics 
+         ;                              CALL lim_wri_2      ( kt )      ! Ice outputs 
+         IF( lrst_ice )                 CALL lim_rst_write_2( kt )      ! Ice restart file 
+         !
+      ENDIF
+      !
+   END SUBROUTINE sbc_ice_lim_2
+
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option           Dummy module      NO LIM 2.0 sea-ice model
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE sbc_ice_lim_2 ( kt, kblk )     ! Dummy routine
+      WRITE(*,*) 'sbc_ice_lim_2: You should not have seen this print! error?', kt, kblk
+   END SUBROUTINE sbc_ice_lim_2
+#endif
+
+   !!======================================================================
+END MODULE sbcice_lim_2
Index: trunk/NEMO/OPA_SRC/SBC/sbcmod.F90
===================================================================
--- trunk/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 888)
+++ trunk/NEMO/OPA_SRC/SBC/sbcmod.F90	(revision 888)
@@ -0,0 +1,265 @@
+MODULE sbcmod
+   !!======================================================================
+   !!                       ***  MODULE  sbcmod  ***
+   !! Surface module :  provide to the ocean its surface boundary condition
+   !!======================================================================
+   !! History :  9.0   !  06-07  (G. Madec)  Original code
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   sbc_init       : read namsbc namelist
+   !!   sbc            : surface ocean momentum, heat and freshwater 
+   !!                    boundary conditions
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE daymod          ! calendar
+   USE phycst          ! physical constants
+   USE ocfzpt          ! ocean freezing point
+
+   USE ice_oce         ! sea-ice model : LIM
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+   USE sbcssm          ! surface boundary condition: sea-surface mean variables
+   USE sbcana          ! surface boundary condition: analytical formulation
+   USE sbcflx          ! surface boundary condition: flux formulation
+   USE sbcblk_clio     ! surface boundary condition: bulk formulation : CLIO
+   USE sbcblk_core     ! surface boundary condition: bulk formulation : CORE
+   USE sbcice_if       ! surface boundary condition: ice-if sea-ice model
+   USE sbcice_lim      ! surface boundary condition: LIM 3.0 sea-ice model
+   USE sbcice_lim_2    ! surface boundary condition: LIM 2.0 sea-ice model
+   USE sbccpl          ! surface boundary condition: coupled florulation
+   USE sbcssr          ! surface boundary condition: sea surface restoring
+   USE sbcrnf          ! surface boundary condition: runoffs
+   USE sbcfwb          ! surface boundary condition: freshwater budget
+   USE closea          ! closed sea
+
+   USE prtctl          ! Print control                    (prt_ctl routine)
+   USE restart         ! ocean restart
+   USE iom
+   USE in_out_manager  ! I/O manager
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   sbc        ! routine called by step.F90
+   
+   !! * namsbc namelist (public variables)
+   LOGICAL , PUBLIC ::   ln_ana      = .FALSE.   !: analytical boundary condition flag
+   LOGICAL , PUBLIC ::   ln_flx      = .FALSE.   !: flux      formulation
+   LOGICAL , PUBLIC ::   ln_blk_clio = .FALSE.   !: CLIO bulk formulation
+   LOGICAL , PUBLIC ::   ln_blk_core = .FALSE.   !: CORE bulk formulation
+   LOGICAL , PUBLIC ::   ln_cpl      = .FALSE.   !: coupled   formulation (overwritten by key_sbc_coupled )
+   LOGICAL , PUBLIC ::   ln_dm2dc    = .FALSE.   !: Daily mean to Diurnal Cycle short wave (qsr)
+   LOGICAL , PUBLIC ::   ln_rnf      = .FALSE.   !: runoffs / runoff mouths
+   LOGICAL , PUBLIC ::   ln_ssr      = .FALSE.   !: Sea Surface restoring on SST and/or SSS      
+   INTEGER , PUBLIC ::   nn_ice      = 0         !: flag on ice in the surface boundary condition (=0/1/2)
+   INTEGER , PUBLIC ::   nn_fwb      = 0         !: type of FreshWater Budget control (=0/1/2)
+   NAMELIST/namsbc/ nn_fsbc, ln_ana, ln_flx, ln_blk_clio, ln_blk_core, ln_cpl,   &
+      &             nn_ice , ln_dm2dc, ln_rnf, ln_ssr, nn_fwb
+
+   INTEGER ::   nsbc   ! type of surface boundary condition (deduced from namsbc informations)
+   INTEGER ::   nice   ! type of ice in the surface boundary condition (deduced from namsbc informations)
+      
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+   !!----------------------------------------------------------------------
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $Id: $
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE sbc_init
+      !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE sbc_init ***
+      !!
+      !! ** Purpose :   Initialisation of the ocean surface boundary computation
+      !!
+      !! ** Method  :   Read the namsbc namelist and set derived parameters
+      !!
+      !! ** Action  : - read namsbc parameters
+      !!              - nsbc: type of sbc
+      !!----------------------------------------------------------------------
+      INTEGER ::   icpt      ! temporary integer
+      !!----------------------------------------------------------------------
+
+      IF(lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'sbc_init : surface boundary condition setting'
+         WRITE(numout,*) '~~~~~~~~ '
+      ENDIF
+
+      REWIND ( numnam )                   ! Read Namelist namsbc
+      READ   ( numnam, namsbc )
+
+      ! overwrite namelist parameter using CPP key information
+!!gmhere no overwrite, test all option via namelist change: require more incore memory
+!!gm  IF( lk_sbc_cpl       ) THEN   ;   ln_cpl      = .TRUE.   ;   ELSE   ;   ln_cpl      = .FALSE.   ;   ENDIF
+      IF( lk_lim2 )            nn_ice      = 2
+      IF( lk_lim3 )            nn_ice      = 3
+      IF( cp_cfg == 'gyre' ) THEN
+          ln_ana      = .TRUE.   
+          nn_ice      =   0
+      ENDIF
+      
+      ! Control print
+      IF(lwp) THEN
+         WRITE(numout,*) '        Namelist namsbc (overwritten using CPP key defined)'
+         WRITE(numout,*) '           frequency update of sbc (and ice)             nn_fsbc     = ', nn_fsbc
+         WRITE(numout,*) '           Type of sbc : '
+         WRITE(numout,*) '              analytical formulation                     ln_ana      = ', ln_ana
+         WRITE(numout,*) '              flux       formulation                     ln_flx      = ', ln_flx
+         WRITE(numout,*) '              CLIO bulk  formulation                     ln_blk_clio = ', ln_blk_clio
+         WRITE(numout,*) '              CLIO bulk  formulation                     ln_blk_core = ', ln_blk_core
+         WRITE(numout,*) '              coupled    formulation (T if key_sbc_cpl)  ln_cpl      = ', ln_cpl
+         WRITE(numout,*) '           Misc. options of sbc : '
+         WRITE(numout,*) '              ice management in the sbc (=0/1/2)         nn_ice      = ', nn_ice 
+         WRITE(numout,*) '              daily mean to diurnal cycle qsr            ln_dm2dc    = ', ln_dm2dc 
+         WRITE(numout,*) '              runoff / runoff mouths                     ln_rnf      = ', ln_rnf
+         WRITE(numout,*) '              Sea Surface Restoring on SST and/or SSS    ln_ssr      = ', ln_ssr
+         WRITE(numout,*) '              FreshWater Budget control  (=0/1/2)        nn_fwb      = ', nn_fwb
+         WRITE(numout,*) '              closed sea (=0/1) (set in namdom)          nclosea     = ', nclosea
+      ENDIF
+
+      ! Check consistancy   !!gm mixture of real and integer : coding to be changed....
+
+      IF( .NOT. ln_rnf )   nn_runoff = 0      ! no runoff, or runoff mouths
+
+      IF( nn_ice == 2 )   THEN
+         IF( MOD( nitend - nit000 + 1, nn_fsbc) /= 0 ) THEN 
+            WRITE(ctmp1,*) 'experiment length (', nitend - nit000 + 1, ') is NOT a multiple of nn_fsbc (', nn_fsbc, ')'
+            CALL ctl_stop( ctmp1, 'Impossible to do proper restart files' )
+         ENDIF
+         IF( MOD( nstock, nn_fsbc) /= 0 ) THEN 
+            WRITE(ctmp1,*) 'nstock ('           , nstock             , ') is NOT a multiple of nn_fsbc (', nn_fsbc, ')'
+            CALL ctl_stop( ctmp1, 'Impossible to do proper restart files' )
+         ENDIF
+      ENDIF
+
+      IF( MOD( rday, nn_fsbc*rdt ) /= 0 )   CALL ctl_warn( 'nn_fsbc is NOT a multiple of the number of time steps in a day' )
+
+      IF( nn_ice == 2 .AND. .NOT.( ln_blk_clio .OR. ln_blk_core ) )   &
+         &   CALL ctl_stop( 'sbc_init: sea-ice model requires a bulk formulation' )
+      
+      ! Choice of the Surface Boudary Condition (set nsbc)
+      icpt = 0
+      IF( ln_ana          ) THEN   ;   nsbc =  1   ; icpt = icpt + 1   ;   ENDIF       ! analytical      formulation
+      IF( ln_flx          ) THEN   ;   nsbc =  2   ; icpt = icpt + 1   ;   ENDIF       ! flux            formulation
+      IF( ln_blk_clio     ) THEN   ;   nsbc =  3   ; icpt = icpt + 1   ;   ENDIF       ! CLIO bulk       formulation
+      IF( ln_blk_core     ) THEN   ;   nsbc =  4   ; icpt = icpt + 1   ;   ENDIF       ! CORE bulk       formulation
+      IF( ln_cpl          ) THEN   ;   nsbc =  5   ; icpt = icpt + 1   ;   ENDIF       ! Coupled         formulation
+      IF( cp_cfg == 'gyre') THEN   ;   nsbc =  0                       ;   ENDIF       ! GYRE analytical formulation
+      IF( lk_esopa        )            nsbc = -1                                       ! esopa test, ALL formulations
+
+      IF( icpt /= 1 .AND. .NOT.lk_esopa ) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) '           E R R O R in setting the sbc, one and only one namelist/CPP key option '
+         WRITE(numout,*) '                     must be choosen. You choose ', icpt, ' option(s)'
+         WRITE(numout,*) '                     We stop'
+         nstop = nstop + 1
+      ENDIF
+      IF(lwp) THEN
+         WRITE(numout,*)
+         IF( nsbc == -1 )   WRITE(numout,*) '              ESOPA test All surface boundary conditions'
+         IF( nsbc ==  0 )   WRITE(numout,*) '              GYRE analytical formulation'
+         IF( nsbc ==  1 )   WRITE(numout,*) '              analytical formulation'
+         IF( nsbc ==  2 )   WRITE(numout,*) '              flux formulation'
+         IF( nsbc ==  3 )   WRITE(numout,*) '              CLIO bulk formulation'
+         IF( nsbc ==  4 )   WRITE(numout,*) '              CORE bulk formulation'
+         IF( nsbc ==  5 )   WRITE(numout,*) '              coupled formulation'
+      ENDIF
+      !
+   END SUBROUTINE sbc_init
+
+
+   SUBROUTINE sbc( kt )
+      !!---------------------------------------------------------------------
+      !!                    ***  ROUTINE sbc  ***
+      !!              
+      !! ** Purpose :   provide at each time-step the ocean surface boundary
+      !!                condition (momentum, heat and freshwater fluxes)
+      !!
+      !! ** Method  :   blah blah  to be written ????????? 
+      !!                CAUTION : never mask the surface stress field (tke sbc)
+      !!
+      !! ** Action  : - set the ocean surface boundary condition, i.e.  
+      !!                utau, vtau, qns, qsr, emp, emps, qrp, erp
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT(in) ::   kt       ! ocean time step
+      !!---------------------------------------------------------------------
+
+      IF( kt == nit000 )   CALL sbc_init         ! Read namsbc namelist : surface module
+
+      ! ocean to sbc mean sea surface variables (ss._m)
+      ! ---------------------------------------
+      CALL sbc_ssm( kt )                         ! sea surface mean currents (at U- and V-points), 
+      !                                          ! temperature and salinity (at T-point) over nf_sbc time-step
+      !                                          ! (i.e. sst_m, sss_m, ssu_m, ssv_m)
+
+!!gm  add a flag on nn_fsbc frequency ?????  except the diurnal cycle!
+!!    IF( MOD( kt - 1, nn_fsbc ) == 0 ) THEN
+
+
+      ! sbc formulation
+      ! ---------------
+         
+      SELECT CASE( nsbc )                        ! Compute ocean surface boundary condition
+      !                                          ! (i.e. utau,vtau, qns, qsr, emp, emps)
+      CASE(  0 )   ;   CALL sbc_gyre    ( kt )      ! analytical formulation : GYRE configuration
+      CASE(  1 )   ;   CALL sbc_ana     ( kt )      ! analytical formulation : uniform sbc
+      CASE(  2 )   ;   CALL sbc_flx     ( kt )      ! flux formulation
+      CASE(  3 )   ;   CALL sbc_blk_clio( kt )      ! bulk formulation : CLIO for the ocean
+      CASE(  4 )   ;   CALL sbc_blk_core( kt )      ! bulk formulation : CORE for the ocean
+      CASE(  5 )   ;   CALL sbc_cpl     ( kt )      ! coupled formulation
+      CASE( -1 )                                
+         ;             CALL sbc_ana     ( kt )      ! ESOPA, test ALL the formulations
+         ;             CALL sbc_gyre    ( kt )
+         ;             CALL sbc_flx     ( kt )
+         ;             CALL sbc_blk_clio( kt )
+         ;             CALL sbc_blk_core( kt )
+         ;             CALL sbc_cpl     ( kt )
+      END SELECT
+
+      ! Misc. Options
+      ! -------------
+
+!!gm  IF( ln_dm2dc       )   CALL sbc_dcy( kt )                 ! Daily mean qsr distributed over the Diurnal Cycle
+      
+      SELECT CASE( nn_ice )                                     ! Update sbc over ice-covered areas
+      CASE(  1 )   ;         CALL sbc_ice_if ( kt )                  ! Ice-cover climatology ("Ice-if" model)
+         !                                                           ! (update heat and freshwater fluxes)
+      CASE(  2 )   ;         CALL sbc_ice_lim_2( kt, nsbc )          ! LIM 2.0 ice model
+         !                                                           ! (update heat and freshwater fluxes)
+      CASE(  3 )   ;         CALL sbc_ice_lim  ( kt, nsbc )          ! LIM 3.0 ice model
+      END SELECT                                                     ! (update all fluxes using bulk + LIM)
+
+      IF( ln_ssr         )   CALL sbc_ssr( kt )                 ! add SST/SSS damping term
+
+      IF( ln_rnf         )   CALL sbc_rnf( kt )                 ! add runoffs to fresh water fluxes
+ 
+      IF( nn_fwb    /= 0 )   CALL sbc_fwb( kt, nn_fwb, nn_fsbc )         ! control the freshwater budget
+
+      IF( nclosea == 1 )   CALL sbc_clo( kt )                   ! treatment of closed sea in the model domain 
+      !                                                         ! (update freshwater fluxes)
+      !
+      IF(ln_ctl) THEN         ! print mean trends (used for debugging)
+         CALL prt_ctl(tab2d_1=emp    , clinfo1=' emp  - : ', mask1=tmask, ovlap=1)
+         CALL prt_ctl(tab2d_1=emps   , clinfo1=' emps - : ', mask1=tmask, ovlap=1)
+         CALL prt_ctl(tab2d_1=qns    , clinfo1=' qns  - : ', mask1=tmask, ovlap=1)
+         CALL prt_ctl(tab2d_1=qsr    , clinfo1=' qsr  - : ', mask1=tmask, ovlap=1)
+         CALL prt_ctl(tab3d_1=tmask  , clinfo1=' tmask  : ', mask1=tmask, ovlap=1, kdim=jpk)
+         CALL prt_ctl(tab3d_1=tn     , clinfo1=' sst  - : ', mask1=tmask, ovlap=1, kdim=1)
+         CALL prt_ctl(tab3d_1=sn     , clinfo1=' sss  - : ', mask1=tmask, ovlap=1, kdim=1)
+         CALL prt_ctl(tab2d_1=utau   , clinfo1=' utau - : ', mask1=umask, &
+                      tab2d_2=vtau   , clinfo2=' vtau - : ', mask2=vmask, ovlap=1)
+      ENDIF
+
+!!gm
+!!    ENDIF
+!!gm
+      !
+   END SUBROUTINE sbc
+
+   !!======================================================================
+END MODULE sbcmod
